﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CharSystem : MonoBehaviour
{

    [SerializeField]
    CtrlPlayerChar playerChar;

    // 0 - UP_RIGHT, 1 - UP_LEFT, 2 - DOWN_RIGHT, 3 - DOWN_LEFT, 4 - NONE
    [SerializeField]
    CtrlCharType2[] characterTR = new CtrlCharType2[0];
    [SerializeField]
    CtrlCharType2[] characterTL = new CtrlCharType2[0];
    [SerializeField]
    CtrlCharType2[] characterDR = new CtrlCharType2[0];
    [SerializeField]
    CtrlCharType2[] characterDL = new CtrlCharType2[0];

    int id = 0;

    void Start()
    {

    }

    void Update()
    {/*
        if (Input.GetKeyDown(KeyCode.F))
        {
            playerChar.WaveIn(Direction.UP_LEFT, 0.8f);
            AIWaveSelection(Direction.UP_LEFT, 0.8f);
        }
        else if (Input.GetKeyDown(KeyCode.V))
        {
            playerChar.WaveIn(Direction.DOWN_LEFT, 0.8f);
            AIWaveSelection(Direction.DOWN_LEFT, 0.8f);
        }
        else if (Input.GetKeyDown(KeyCode.G))
        {
            playerChar.WaveIn(Direction.UP_RIGHT, 0.8f);
            AIWaveSelection(Direction.UP_RIGHT, 0.8f);
        }
        else if (Input.GetKeyDown(KeyCode.B))
        {
            playerChar.WaveIn(Direction.DOWN_RIGHT, 0.8f);
            AIWaveSelection(Direction.DOWN_RIGHT, 0.8f);
        }
        else if (Input.GetKeyDown(KeyCode.N))
        {
            playerChar.WaveIn(Direction.FAIL, 0.8f);
        }*/
    }


    public void BeatNow()
    {
        //Debug.Log("BeatNow \n");
        for (int i = 0; i < characterTL.Length; i++)
        {
            characterTL[i].PlayHeadBob();
        }

        for (int i = 0; i < characterTR.Length; i++)
        {
            characterTR[i].PlayHeadBob();
        }

        for (int i = 0; i < characterDL.Length; i++)
        {
            characterDL[i].PlayHeadBob();
        }

        for (int i = 0; i < characterDR.Length; i++)
        {
            characterDR[i].PlayHeadBob();
        }

    }


    /// <summary>
    /// Do wave anim on player or characters
    /// </summary>
    /// <param name="turn">Player or AI turn</param>
    /// <param name="dir">Direction of hand waving</param>
    /// <param name="delay">Delay before next note</param>
    public void DoCharacterWave(EnumActionTurn turn, Direction dir, float delay = -1f)
    {
        if (turn == EnumActionTurn.player) playerChar.WaveIn(dir, delay);
        else AIWaveSelection(dir, delay);
    }


    void AIWaveSelection(Direction dir, float delay)
    {
        switch (dir)
        {
            case Direction.UP_LEFT:
                if (characterTL.Length <= 0) Debug.LogError("CharSystem AIWaveSelection : empty array !");
                else
                {
                    for (int i = 0; i< characterTL.Length; i++)
                    {
                        characterTL[i].WaveIn(delay);
                    }
                    /*
                    if (id >= characterTL.Length) id = 0;
                    characterTL[id].WaveIn(delay);
                    id++;
                    */
                }
                break;

            case Direction.UP_RIGHT:
                if (characterTR.Length <= 0) Debug.LogError("CharSystem AIWaveSelection : empty array !");
                else
                {
                    for (int i = 0; i < characterTR.Length; i++)
                    {
                        characterTR[i].WaveIn(delay);
                    }
                    /*
                    if (id >= characterTR.Length) id = 0;
                    characterTR[id].WaveIn(delay);
                    id++;*/
                }
                break ;

            case Direction.DOWN_LEFT:
                if (characterDL.Length <= 0) Debug.LogError("CharSystem AIWaveSelection : empty array !");
                else
                {
                    for (int i = 0; i < characterDL.Length; i++)
                    {
                        characterDL[i].WaveIn(delay);
                    }
                    /*
                    if (id >= characterDL.Length) id = 0;
                    characterDL[id].WaveIn(delay);
                    id++;*/
                }
                break;

            case Direction.DOWN_RIGHT:
                if (characterDR.Length <= 0) Debug.LogError("CharSystem AIWaveSelection : empty array !");
                else
                {
                    for (int i = 0; i < characterDR.Length; i++)
                    {
                        characterDR[i].WaveIn(delay);
                    }
                    /*
                    if (id >= characterDR.Length) id = 0;
                    characterDR[id].WaveIn(delay);
                    id++;*/
                }
                break;
        }
    }

}
