﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CtrlCharType2 : MonoBehaviour
{

    public Sprite teteSprite1;
    public Sprite teteSprite2;

    private GameObject sCorp;
    private GameObject sCorpWave;
    private GameObject sTete;
    private SpriteRenderer sRendrTete;
    private GameObject sHand;
    private HandAnim sHandComp;
    private CtrlTete ctrlTete;
    private float waveTime = 0.8f;


    void Awake()
    {
        sCorp = this.transform.FindChild("Corps").gameObject;
        sCorpWave = this.transform.FindChild("CorpsWave").gameObject;

        sTete = this.transform.FindChild("Tete").gameObject;
        ctrlTete = sTete.transform.GetComponent<CtrlTete>();
        sRendrTete = sTete.transform.GetComponent<SpriteRenderer>();

        sHand = this.transform.FindChild("Hand").gameObject;
        sHandComp = this.transform.FindChild("Hand").transform.GetComponent<HandAnim>();
    }


    public void WaveIn(float holdWaveTime)
    {
        sCorp.SetActive(false);
        sCorpWave.SetActive(true);
        sRendrTete.sprite = teteSprite2;
        sHand.SetActive(true);

        //CancelInvoke();
        //Invoke("WaveOut", holdWaveTime);

        CancelInvoke();
        float t = waveTime;
        if (holdWaveTime < waveTime)
        {
            t = Mathf.Max(0.2f, holdWaveTime - 0.2f);
        }
        Invoke("WaveOut", t);
    }

    public void WaveOut()
    {
        sCorp.SetActive(true);
        sCorpWave.SetActive(false);
        sRendrTete.sprite = teteSprite1;
        sHandComp.ResetRot();
        sHand.SetActive(false);
    }


    public void PlayHeadBob()
    {
        ctrlTete.PlayHeadBob();
    }

}
