﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CtrlPlayerChar : MonoBehaviour
{

    // 0 - UP_RIGHT, 1 - UP_LEFT, 2 - DOWN_RIGHT, 3 - DOWN_LEFT, 4 - NONE
    public GameObject[] sCorpWave = new GameObject[4];
    public HandAnim[] sHandComp = new HandAnim[4];

    private GameObject sCorp;
    private GameObject sCorpFail;
    private Direction lastDirection = Direction.NONE;
    private float waveTime = 0.8f;


    void Awake()
    {
        sCorp = this.transform.FindChild("Corps").gameObject;
        sCorpFail = this.transform.FindChild("CorpsFail").gameObject;
    }

    public void WaveIn(Direction dir,float holdWaveTime)
    {
        if (lastDirection != Direction.NONE) WaveOut();

        if (dir == Direction.FAIL) WaveFail();
        else
        {
            lastDirection = dir;
            sCorp.SetActive(false);
            sCorpWave[(int)dir].SetActive(true);

            CancelInvoke();
            float t = waveTime;
            if (holdWaveTime < waveTime)
            {
                t = Mathf.Max(0.2f, holdWaveTime - 0.2f);
            }
            Invoke("WaveOut", t);
        }
    }


    void WaveOut()
    {
        CancelInvoke();
        sCorp.SetActive(true);
        sCorpFail.SetActive(false);
        sHandComp[(int)lastDirection].ResetRot();
        sCorpWave[(int)lastDirection].SetActive(false);
        lastDirection = Direction.NONE;
    }


    public void WaveFail()
    {
        if (lastDirection != Direction.NONE) WaveOut();
        sCorp.SetActive(false);
        sCorpFail.SetActive(true);
        Invoke("WaveFailOut", 0.4f);
    }


    void WaveFailOut()
    {
        sCorp.SetActive(true);
        sCorpFail.SetActive(false);
    }

}
