﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class InputManager : MonoBehaviour {

    public SongManager songManager;
    public CtrlMenu ctrlMenu;

    private bool isGame = false;
    private bool isPlaying = false;
    private bool isPressed = false;
    // Resume button
    // Restart button
	
	// Update is called once per frame
	void Update () {
        if (isGame)
        {
            if (Input.GetKeyDown(KeyCode.Space))
            {
                if (isPlaying)
                {
                    Time.timeScale = 0;
                    isPlaying = false;
                    songManager.Pause(true);
                    ctrlMenu.Pause();
                }
                else
                {
                    Time.timeScale = 1;
                    isPlaying = true;
                    songManager.Pause(false);
                    ctrlMenu.UnPause();
                }
            }
        }

        if (isPlaying)
        {
            if (Input.GetKeyDown(KeyCode.W))
            {
                songManager.PlayerSendNote(Direction.UP_LEFT);
            }
            else if (Input.GetKeyDown(KeyCode.A))
            {
                songManager.PlayerSendNote(Direction.DOWN_LEFT);
            }
            else if (Input.GetKeyDown(KeyCode.O))
            {
                songManager.PlayerSendNote(Direction.UP_RIGHT);
            }
            else if (Input.GetKeyDown(KeyCode.L))
            {
                songManager.PlayerSendNote(Direction.DOWN_RIGHT);
            }
        }

        else
        {
            if (Input.GetKeyDown(KeyCode.Return))
            {
                Time.timeScale = 1;
                isPlaying = true;
                isGame = true;
                songManager.Restart();
                ctrlMenu.StartGame();
            }
        }
    }
}
